@echo off

SETLOCAL EnableDelayedExpansion
cls

echo ===================================================================================
echo  ਯ  ᠭ  訢 ESP8266 묨 䠩
echo 訢   ---  https://forum.homedistiller.ru/index.php?topic=343606.700
echo  ᫠  --- https://yoomoney.ru/to/410012916703619
echo Phisik (C) 2021
echo ===================================================================================
ECHO.
ECHO.

rem  ࠡ 䫥誨 qio - ᠬ , dout - ᠬ ᮢ⨬
rem qio, dio, dout, qout
set FLASH_MODE=qio


rem Com port selection
rem ===================================================================================

:com_start
set CNT=1
for /f "delims=" %%I in ('wmic path Win32_SerialPort get Name /format:list ^| find "="') do (
    set "%%I"
	for /f "tokens=2 delims==\(\)" %%a in ("!Name!") do set "COM!CNT!=%%a"	
	echo [!CNT!] !Name!
	set /A CNT=!CNT!+1
)
set choice=
set /p choice="롥 COM : "
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%' GEQ %CNT% goto com_error
if '%choice%' LSS 1 goto com_error
goto com_ok

:com_error
ECHO     ᯨ᪥ ("%choice%")
ECHO.
goto com_start

:com_ok
set "COMn=COM%choice%"


rem Baudrate selection
rem ===================================================================================

:baudrate_start
ECHO.
ECHO [1] 921600
ECHO [2] 512000
ECHO [3] 230400
ECHO [4] 115200
ECHO [5] 57600
set choice=
set /p choice="롥 ᪮ 祭 ( Enter  롮 921600 ): "
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='' goto baudrate1
if '%choice%'=='1' goto baudrate1
if '%choice%'=='2' goto baudrate2
if '%choice%'=='3' goto baudrate3
if '%choice%'=='4' goto baudrate4
if '%choice%'=='5' goto baudrate5
ECHO     ᯨ᪥ ("%choice%")
ECHO.
goto baudrate_start

:baudrate1
set BAUDRATE=921600
goto baudrate_end
:baudrate2
set BAUDRATE=512000
goto baudrate_end
:baudrate3
set BAUDRATE=230400
goto baudrate_end
:baudrate4
set BAUDRATE=115200
goto baudrate_end
:baudrate5
set BAUDRATE=57600
goto baudrate_end
:baudrate_end


rem Programming type selection
rem ===================================================================================

:type_start
ECHO.
ECHO [1] 訢 (firmware)
ECHO [2]  ⥬ (spiffs)
ECHO [3] 訢  䠩 ⥬ (firmware+spiffs)
set type=
set /p type="롥  㤥 ணࠬ஢: "
if not '%type%'=='' set type=%type:~0,1%
if '%type%'=='1' goto fw_start
if '%type%'=='2' goto spiffs_start
if '%type%'=='3' goto fw_start

ECHO     ᯨ᪥ ("%type%")
ECHO.
goto type_start

rem FW file selection
rem ===================================================================================

:fw_start
ECHO.
set CNT=1
for /f "delims=" %%I in ('dir /b *.bin') do (
    set "FILE!CNT!=%%I"	
	echo [!CNT!] %%I
	set /A CNT=!CNT!+1
)
set choice=
set /p choice="롥 䠩  訢 (firmware): "
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%' GEQ %CNT% goto fw_error
if '%choice%' LSS 1 goto fw_error
goto fw_end

:fw_error
ECHO     ᯨ᪥ ("%choice%")
goto fw_start

:fw_end
set "FIRMWARE=FILE%choice%"

rem SPIFFS file selection
rem ===================================================================================

if '%type%'=='1' goto spiffs_end

:spiffs_start
ECHO.
set CNT=1
for /f "delims=" %%I in ('dir /b *.bin') do (
    set "FILE!CNT!=%%I"	
	echo [!CNT!] %%I
	set /A CNT=!CNT!+1
)
set choice=
set /p choice="롥 䠩  䠩 ⥬ (SPIFFS): "
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%' GEQ %CNT% goto spiffs_error
if '%choice%' LSS 1 goto spiffs_error
goto spiffs_end

:spiffs_error
ECHO     ᯨ᪥ ("%choice%")
goto spiffs_start

:spiffs_end
set "SPIFFS=FILE%choice%"

if '%type%'=='1' goto flash_fw
if '%type%'=='2' goto flash_spiffs
if '%type%'=='3' goto flash_both


:flash_fw
ECHO.
echo =================================================================================
echo 뢠 !%FIRMWARE%!...
echo (COM=!%COMn%!, BAUDRATE=%BAUDRATE%, ADDRESS=0x000000)
echo =================================================================================
ECHO.

esptool     --port !%COMn%! --baud %BAUDRATE% --after hard_reset ^
 			write_flash --flash_size detect --flash_mode %FLASH_MODE% ^
 			0x000000 !%FIRMWARE%!

goto script_end

:flash_spiffs
ECHO.
echo =================================================================================
echo 뢠 !%SPIFFS%!...
echo (COM=!%COMn%!, BAUDRATE=%BAUDRATE%, ADDRESS=0x100000)
echo =================================================================================
ECHO.

esptool     --port !%COMn%! --baud %BAUDRATE% --after hard_reset ^
 			write_flash --flash_size detect --flash_mode %FLASH_MODE% ^
 			0x100000 !%SPIFFS%!

goto script_end

:flash_both
ECHO.
echo =================================================================================
echo 뢠 !%FIRMWARE%!  !%SPIFFS%!...
echo (COM=!%COMn%!, BAUDRATE=%BAUDRATE%, ADDRESS=0x000000)
echo =================================================================================
ECHO.

esptool     --port !%COMn%! --baud %BAUDRATE% --after hard_reset ^
 			write_flash --flash_size detect --flash_mode %FLASH_MODE% ^
 			0x000000 !%FIRMWARE%! 0x100000 !%SPIFFS%!

:script_end
pause